using System ;
using System.Collections.Generic ;
using System.ComponentModel ;
using System.Data ;
using System.Drawing ;
using System.Linq ;
using System.Text ;
using System.Windows.Forms ;
using System.IO ;
using System.Xml.Serialization ;
using System.Threading ;

namespace SanwaNewtec.Demonstrate.SampleRWControlCS
{
  using SanwaNewtec.DeviceControls ; // Oaj[ebN[_C^䃉Cugp
  using Common ; // ʒ`֐
  using Datas  ; // AvP[V֌Wf[^
  ///===================================================================================================
  /// <summary>
  /// s`DʃNXt
  /// ύX
  ///   2006/10/25 ( kw ) 
  /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
  /// </summary>
  public partial class MainFrame: Form
  {
    ///=================================================================================================
    /// <summary>
    /// s`DPD[U[uCN̂߂̃_~[ONXt
    /// </summary>
    public class UserBreakException: Exception 
    {
    }
    public class WriteData
    {
      public List<string> _strings ;
      public bool         _hex ;
    }

    /// <summary>\̏iHH:mm:ssj</summary>
    const string _fmtTime= "HH:mm:ss" ;
    /// <summary>t\̏iyyyy/MM/dd HH:mm:ss:fffj</summary>
    const string _fmtDateTimeMS= "yyyy/MM/dd HH:mm:ss:fff" ;
    const string _fmtEndstatus="I [RPS1=0x{0:X2}, RPS2=0x{1:X2}, 0xRPS3=0x{2:X2}]";
    /// <summary>\x̕</summary>
    const int _clockWidth= 60 ;
    
    # region f[^oɊւ
    /// <summary>R/WRg[iGAXj</summary>
    V31Control _rwControl= null ;
    /// <summary>VARg[iiIj</summary>
    V31SerialControl _comControl= null ;
    /// <summary>USBRg[iiIj</summary>
    V31USBControl _usbControl= null ;
    /// <summary>Avf[^iꎞIj</summary>
    AppData _wrkData= null ;
    /// <summary>Avf[^ifBXNf[^j</summary>
    AppData _orgData= null;
    # endregion

    ///*************************************************************************************************
    /// <summary>
    /// ŗ^ɌݎtāAʂ̍ŉʗ̈ɕ\
    /// ύX
    ///   2006/10/25 ( kw ) 
    /// </summary>
    /// <param name="msg"></param>
    private void ROUT(string msg )
    {
      mmR.AppendText( DateTime.Now.ToString(_fmtDateTimeMS )+ " "+ msg+ "\n" ) ;
    }
    private void ROUT(string msg, byte[] data )
    {
      ROUT( msg ) ;
      mmR.AppendText( ComDef.CC(data ) ) ;
    }

    # region RXgN^Ɋւ
    ///*************************************************************************************************
    /// <summary>
    /// y`DftHgRXgN^z
    /// ύX
    ///   2006/10/25 ( kw ) 
    /// </summary>
    public MainFrame()
    {
      InitializeComponent();
      // \x̏ʒuݒ
      _slClock.Margin= new Padding(sbMain.Width- _clockWidth, 1, 1 ,1 ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// AvςɉăRg[̗L^ݒs
    /// ύX
    ///   2006/10/25 ( kw ) 
    ///   2009/06/17 ( kw ) USBRg[ǉɂ锻C
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void RefreshControls(object sender, EventArgs e)
    {
      bool bOpen= _rwControl.IsOpen ;
      //
      gbControl.Enabled= !bOpen ;
      btConn   .Text   =  bOpen ? "؁@f" : "ځ@";

      if(_rwControl== _usbControl ){
        // USB Rg[L
        cbPortName.Enabled= false ;
        cbBaudRate.Enabled= false ;
        cbParity  .Enabled= false ;
        cbStopBits.Enabled= false ;
        lbPortName.Enabled= false ;
        lbBaudRate.Enabled= false ;
        lbParity  .Enabled= false ;
        lbStopBits.Enabled= false ;
        lbCTS     .Enabled= false ;
        lbCTS     .Text   = "CTS-OFF" ;
        //
        bOpen= _usbControl.IsOpen ;
        lbRPS1.Enabled=  bOpen ;
        lbRPS2.Enabled=  bOpen ;
        lbRPS3.Enabled=  bOpen ;
      }else {
        // VARg[L
        lbPortName.Enabled= true ;
        lbBaudRate.Enabled= true ;
        lbParity  .Enabled= true ;
        lbStopBits.Enabled= true ;
        //
        bOpen= _comControl.IsOpen ;
        cbPortName.Enabled= !bOpen ;
        cbBaudRate.Enabled= !bOpen ;
        cbParity  .Enabled= !bOpen ;
        cbStopBits.Enabled= !bOpen ;
        lbCTS     .Enabled=  bOpen ;
        lbRPS1    .Enabled=  bOpen ;
        lbRPS2    .Enabled=  bOpen ;
        lbRPS3    .Enabled=  bOpen ;
        if(!bOpen ){
          lbCTS.Text= "CTS-OFF" ;
        }
          
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// AvP[V̓ɕKvȃf[^̏ݒȂǂs
    /// ύX
    ///   2006/10/25 ( kw ) 
    ///   2006/11/10 ( kw ) wvvoC_̏ݒǉ
    /// @2009/06/17 ( kw )
    /// @@AvP[Vf[^ɂ킹ăRg[CX^X𐶐悤ɕύX
    ///   2014/10/23  (k.kondo)  ISOWriteTrackpRg[ǉ
    ///   2014/10/24  (k.kondo)  Cg(ISOl)p`FbN{bNXݒǉ
    ///                          Cg(ISOl)Cf[^eLXg{bNXpToolTipݒ
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void MainFrame_Load(object sender, EventArgs e)
    {
      //
      // p[^ݒ̂߂̃Rg[ɏl^
      CommPort     .SetControls(cbPortName, cbBaudRate, cbParity, cbStopBits, nuTimeout, nuRetryTime ) ;
      Initialize   .SetControls(cbIniMode, cbRspMode ) ;
      Read         .SetControls(cbReadMode, cbReadCheck, cbReadTrack ) ;
      Write        .SetControls(cbWriteMode, cbWriteCheck, cbWriteTrack ) ;
      RegisterGaiji.SetControls(nuGaijiNo, cbGaijiSize ) ;
      RegisterImage.SetControls(nuRegisterImageAddress, nuRegisterImageWidth, nuRegisterImageHeight ) ;
      PrintSetting .SetControls(cbPrintSettingCard, cbPrintSettingMode, cbPrintSettingAlign, cbPrintSettingFont ) ;
      PrintImage   .SetControls(cbPrintImageMode, cbPrintImageClear, nuPrintImageWidth, nuPrintImageHeight, nuPrintImageX, nuPrintImageY, nuPrintImageAddress, cbPrintImageByAddress ) ;
      PrintString  .SetControls(cbPrintStringMode, cbPrintStringClear, nuPrintStringLine ) ;
      PrintBarcode .SetControls(cbPrintBarcodeMode, cbPrintBarcodeClear, cbPrintBarcodeKind, cbPrintBarcodeTip, cbPrintBarcodeWidth, nuPrintBarcodeHeight, nuPrintBarcodeX, nuPrintBarcodeY ) ;
      ISOWrite.SetControls( cbISOWriteTrack );
      //
      // Xe[^Xo[Ɏ\悤ɂ
      sbMain.Resize+= delegate{ _slClock.Margin= new Padding(sbMain.Width- _clockWidth, 1, 1, 1 ) ; } ;
      tmMain.Tick  += 
        delegate{ 
          _slClock.Text  = DateTime.Now.ToString(_fmtTime ) ;
          if( (_comControl!= null )
            &&(_comControl.IsOpen )
            &&(_comControl.LockEvents ) ){
            // CTSM̏Ԃj^
            if(_comControl.CTS ){
              lbCTS.Text= "CTS-ON" ;
              lbCTS.ForeColor= Color.LimeGreen ;
            }else {
              lbCTS.Text= "CTS-OFF" ;
              lbCTS.ForeColor= Color.Red ;
            }
            lbCTS.Refresh() ;
          }
        } ;
      //
      // wvvoC_̏ݒs
      string appPath = Application.ExecutablePath ;
      string helpPath= Path.GetDirectoryName( appPath )+ "\\"+ Path.GetFileNameWithoutExtension( appPath )+ _helpExt ;
      if(File.Exists( helpPath ) ){
        hpMain.HelpNamespace= helpPath ;
      }
      //
      //@Avf[^fBXNǂݏoAeRg[ݒ肷
      try {
        _orgData= new AppData() ;
        _orgData.Load() ;
        _wrkData= (AppData)_orgData.Clone() ;
        SetControlsFromData() ;

        //Cg(ISOl)p`FbN{bNXݒ
        chWriteTrack1.Checked = true;
        chWriteTrack2.Checked = true;
        chWriteTrack3.Checked = true;

        //Cg(ISOl)Cf[^eLXg{bNXpToolTipݒ
        InitToolTip();

      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "ݒG[" ) ;
      }
      //------------------------------------------------------------------------------------------------
      //  iIȃRg[̍쐬
      //------------------------------------------------------------------------------------------------
      _usbControl  = new V31USBControl   () ;
      _comControl  = new V31SerialControl() ;
      _rwControl   = _usbControl ;
      rbUSB.Checked= true ;
      //
      // CTSON/OFFɍ킹ăx\ύX
      _comControl.ChangeCTS+=
        delegate(object sender2, V31SerialControl.CTSEventArgs e2 )
        {
          if(!_comControl.LockEvents ){
            Invoke(new MethodInvoker(
              delegate
              {
                if(e2.CTS ){
                  lbCTS.Text= "CTS-ON" ;
                  lbCTS.ForeColor= Color.LimeGreen ;
                }else {
                  lbCTS.Text= "CTS-OFF" ;
                  lbCTS.ForeColor= Color.Red ;
                }
                lbCTS.Refresh() ;
              } ) ) ;
          }
        } ;

      tmMain.Enabled= true ;
      RefreshControls(sender, e ) ;
    }
    const string _helpExt= ".chm" ;
    ///*************************************************************************************************
    /// <summary>
    /// R/WƐڑ́AAvIłȂ悤ɂ
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void MainFrame_FormClosing(object sender, FormClosingEventArgs e)
    {
      if(_rwControl.IsOpen ){
        if(!btStartDemo.Enabled ){
          ComDef.EMbxOk("f́AAvIł܂", "AvIG[" ) ;
          e.Cancel= true ;
        }else {
          if(ComDef.QMbxYesNo("R/WƐڑłBؒfăAvP[VI܂H", "Av̏ImF" ) ){
            _rwControl.Close() ;
          }else {
            e.Cancel= true ;
          }
        }
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Avf[^ۑAʐMRg[j
    /// ύX
    ///   2006/10/25 ( kw ) 
    ///   2009/06/17 ( kw ) USBRg[̔jǉ
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void MainFrame_FormClosed(object sender, FormClosedEventArgs e)
    {
      SetDataFromControls() ;
      if(!_wrkData.Equals( _orgData ) ){
        if(ComDef.QMbxYesNo("ݒ肪ύXĂ܂B\nNɗLɂȂ悤ۑ܂H", "Avf[^̕ۑmF" ) ){
          _wrkData.Save();
        }
      }
      _comControl.Dispose() ; // VARg[j
      _usbControl.Dispose() ; // USBRg[j
    }
    # endregion

    # region R}hɊւ
    ///*************************************************************************************************
    /// <summary>
    /// q^vRg[̃I[v^N[YgOōs
    /// ύX
    ///   2006/10/25 ( kw ) 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btConn_Click(object sender, EventArgs e)
    {
      SetDataFromControls() ;
      if(_rwControl.IsOpen ) _rwControl.Close() ;
      else {
        if(_rwControl== _usbControl ){
          try {
            _usbControl.Open() ;
            ComDef.IMbxOk("ABS-V31Uɐڑ܂", "USBRg[̃I[v" ) ;
          }catch(Exception ex ){
            ComDef.EMbxOk(ex.Message, "USBRg[̃I[vs" ) ;
          }
        }else {
          try {
            ImportCommPort() ;
            CommPort para= _wrkData.CommPort ;
            _comControl.PortName = para.PortName ; // |[g
            _comControl.PortName = para.PortName ; // |[g
            _comControl.BaudRate = para.BaudRate ; // ʐMx
            _comControl.Parity   = para.Parity   ; // peB
            _comControl.StopBits = para.StopBits ; // Xgbvrbg
            _comControl.Timeout  = para.Timeout  ;
            _comControl.RetryTime= para.RetryTime;
            _comControl.Open() ;
          }catch(Exception ex ){
            ComDef.EMbxOk(ex.Message, "VARg[̃I[vs" ) ;
          }
        }
      }
      RefreshControls(sender, e ) ;
    }
    # endregion

    ///*************************************************************************************************
    /// <summary>
    /// f́A^uؑւ֎~
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tbMain_Selecting(object sender, TabControlCancelEventArgs e)
    {
      e.Cancel= (!btStartDemo.Enabled ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void cbPrintImageByAddress_CheckedChanged(object sender, EventArgs e)
    {
      nuPrintImageAddress.Enabled= cbPrintImageByAddress.Checked ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ʂĖ{AvP[VI
    /// ύX
    ///   2006/10/25 ( kw ) 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void miFileExit_Click(object sender, EventArgs e)
    {
      Close() ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// bsqk{qŃ[hR}hs
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void miExecRead_Click(object sender, EventArgs e)
    {
      btRead_Click(sender, e ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// bsqk{dŃX|Xđs
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void miExecGetResponse_Click(object sender, EventArgs e)
    {
      btGetResponse_Click(sender, e ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ReLXgj[ĂяoɂAڂSăNA
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void miCmClear_Click(object sender, EventArgs e)
    {
      Control sc= cmMain.SourceControl ;
      if(sc is TextBox ){
        TextBox tb= (TextBox)sc ;
        tb.Clear() ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// ReLXgj[ĂяoɂAڂɖOtĕۑ
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2014/10/23  (k.kondo)  Cg(ISOl)^ũgbN1`3Cf[^peLXg{bNXĨZ[uǉ
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void miCmSaveAs_Click(object sender, EventArgs e)
    {
      //
      Control sc= cmMain.SourceControl ;
      if(sc is TextBox ){
        TextBox tb= (TextBox)sc ;
        if(     sc== mmR )             SaveAsR            () ;
        else if(sc== edWrite         ) SaveAsWrite        () ;
        else if(sc== edRegisterGaiji ) SaveAsRegisterGaiji() ;
        else if(sc== edRegisterImage ) SaveAsRegisterImage() ;
        else if(sc== edPrintString   ) SaveAsPrintString  () ;
        else if(sc== edPrintImage    ) SaveAsPrintImage   () ;
        else
        {
          //Cg(ISOl)
          if( ( sc == tbWriteTrack1 ) ||
              ( sc == tbWriteTrack2 ) ||
              ( sc == tbWriteTrack3 ) )
          {
            SaveAsISOWrite();
          }
        }
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// ReLXgj[ĂяoɂAt@C獀ڂɌĂяo
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2014/10/23  (k.kondo)  Cg(ISOl)^ũgbN1`3Cf[^peLXg{bNXĨI[vǉ
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void miCmOpen_Click(object sender, EventArgs e)
    {
      Control sc= cmMain.SourceControl ;
      if(sc is TextBox ){
        TextBox tb= (TextBox)sc ;
        if(     sc== mmR )             ComDef.EMbxOk("AvP[VO͓ǂݍ߂܂", "t@CI[vG[" ) ;
        else if(sc== edWrite         ) OpenWrite        () ;
        else if(sc== edRegisterGaiji ) OpenRegisterGaiji() ;
        else if(sc== edRegisterImage ) OpenRegisterImage() ;
        else if(sc== edPrintString   ) OpenPrintString  () ;
        else if(sc== edPrintImage    ) OpenPrintImage   () ;
        else
        {
          //Cg(ISOl)
          if( ( sc == tbWriteTrack1 ) ||
              ( sc == tbWriteTrack2 ) ||
              ( sc == tbWriteTrack3 ) )
          {
            OpenISOWrite();
          }
        }
      }
    }

    #   region R}htf[^̕ۑɊւ鏈
    ///*************************************************************************************************
    /// <summary>
    /// AvP[VOʖۑ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void SaveAsR()
    {
      dlgSave.FileName= DateTime.Now.ToString("yyyyMMdd_HHmmss" )+ "_log.xml" ;
      dlgSave.Filter  = "AvP[VOt@C(*.xml)|*.xml" ;
      if(dlgSave.ShowDialog()== DialogResult.OK ){
        SaveXML(dlgSave.FileName, mmR.Lines ) ;
        mmR.Clear() ;
      }
    }
    #   endregion

    # region CgR}ht@C̓ǂݍ݂ƕۑ
    ///*************************************************************************************************
    /// <summary>
    /// CgR}hf[^ǂݍ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void OpenWrite()
    {
      try {
        dlgOpen.FileName= _wrkData.Write.FileName ;
        dlgOpen.Filter  = "CgR}ht@C(*.xml)|*.xml" ;
        if(dlgOpen.ShowDialog()== DialogResult.OK ){
          OpenXML(dlgOpen.FileName, edWrite, cbWriteHex ) ;
          _wrkData.Write.FileName= dlgOpen.FileName ;
        }
      }
      catch(Exception ex ){
       ComDef.EMbxOk(ex.Message, "CgR}ht@Cǂݍ݃G[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// CgR}hf[^ʖۑ
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2006/11/10 ( kw ) t@CAvf[^ɕۑ悤ɕύX
    /// </summary>
    private void SaveAsWrite()
    {
      try {
        dlgSave.FileName= _wrkData.Write.FileName ;
        dlgSave.Filter  = "CgR}ht@C(*.xml)|*.xml" ;
        if(dlgSave.ShowDialog()== DialogResult.OK ){
          SaveXML(dlgSave.FileName, edWrite.Lines, cbWriteHex.Checked ) ;
          _wrkData.Write.FileName= dlgSave.FileName ;
        }
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "CgR}ht@C݃G[" ) ;
      }
    }
    # endregion

    #region  CgR}h(ISOl)t@C̓ǂݍ݂ƕۑ
    /// <summary>
    /// CgR}hf[^ǂݍ
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    private void OpenISOWrite()
    {
      try
      {
        dlgOpen.FileName = _wrkData.ISOWrite.FileName;
        dlgOpen.Filter = "CgR}h[ISOl]t@C(*.xml)|*.xml";
        if( dlgOpen.ShowDialog() == DialogResult.OK )
        {
          OpenXML( dlgOpen.FileName,
                   tbWriteTrack1,
                   tbWriteTrack2,
                   tbWriteTrack3,
                   chISOWriteHex );
          _wrkData.ISOWrite.FileName = dlgOpen.FileName;
        }
      }
      catch( Exception ex )
      {
        ComDef.EMbxOk( ex.Message,
                       "CgR}h[ISOl]t@Cǂݍ݃G[" );
      }
    }

    /// <summary>
    /// CgR}hf[^ʖۑ
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    private void SaveAsISOWrite()
    {
      string[] strwrt = new string[ 3 ];

      try
      {
        dlgSave.FileName = _wrkData.ISOWrite.FileName;
        dlgSave.Filter = "CgR}h[ISOl]t@C(*.xml)|*.xml";
        if( dlgSave.ShowDialog() == DialogResult.OK )
        {
          strwrt[ 0 ] = tbWriteTrack1.Text;
          strwrt[ 1 ] = tbWriteTrack2.Text;
          strwrt[ 2 ] = tbWriteTrack3.Text;
          SaveXML( dlgSave.FileName,
                   strwrt,
                   chISOWriteHex.Checked );
          _wrkData.ISOWrite.FileName = dlgSave.FileName;
        }
      }
      catch( Exception ex )
      {
        ComDef.EMbxOk( ex.Message,
                       "CgR}h[ISOl]t@C݃G[" );
      }
    }
    #endregion  CgR}h(ISOl)t@C̓ǂݍ݂ƕۑ

    # region Oo^R}ht@C̓ǂݍ݂ƕۑ
    ///*************************************************************************************************
    /// <summary>
    /// Oo^R}hf[^ǂݍ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void OpenRegisterGaiji()
    {
      try {
        dlgOpen.FileName= _wrkData.RegisterGaiji.FileName ;
        dlgOpen.Filter  = "C[Wf[^(*.dat)|*.dat|rbg}bv(*.bmp)|*.bmp" ;
        if(ComDef.IsBitmapFileName( dlgOpen.FileName ) ){
          dlgOpen.FilterIndex= 2 ;
        }
        if(dlgOpen.ShowDialog()== DialogResult.OK ){
          int width = 24 ;
          int height= 24 ;
          OpenBinary(dlgOpen.FileName, edRegisterGaiji, ref width, ref height ) ;
          _wrkData.RegisterGaiji.FileName= dlgOpen.FileName ;
        }
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "Oo^R}ht@Cǂݍ݃G[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Oo^R}hf[^ʖۑ
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2006/11/10 ( kw ) Oo^R}ht@CAvf[^ɕێ悤ύX
    /// </summary>
    private void SaveAsRegisterGaiji()
    {
      try {
        byte[] data= GetRegisterGaijiByteData() ;
        dlgSave.FileName= _wrkData.RegisterGaiji.FileName ;
        dlgSave.Filter  = "Oo^R}ht@C(*.dat)|*.dat" ;
        if(dlgSave.ShowDialog()== DialogResult.OK ){
          using(FileStream fs= new FileStream(dlgSave.FileName, FileMode.Create, FileAccess.Write ) ){
            fs.Write(data, 0, data.Length ) ;
            _wrkData.RegisterGaiji.FileName= dlgSave.FileName ;
          }
        }
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "Oo^R}ht@C݃G[" ) ;
      }
    }
    # endregion

    # region C[Wf[^o^R}ht@C̓ǂݍ݂ƕۑ
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^o^R}hf[^ǂݍ
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2006/11/10 ( kw ) rbg}bvt@Cǂݍ߂悤ɕύX
    /// </summary>
    private void OpenRegisterImage()
    {
      try {
        dlgOpen.FileName= _wrkData.RegisterImage.FileName ;
        dlgOpen.Filter  = "C[Wf[^(*.dat)|*.dat|rbg}bv(*.bmp)|*.bmp" ;
        if(ComDef.IsBitmapFileName(_wrkData.RegisterImage.FileName ) ){
          dlgOpen.FilterIndex= 2 ;
        }
        if(dlgOpen.ShowDialog()== DialogResult.OK ){
          int width = RegisterImage._maxWidth ;
          int height= RegisterImage._maxHeight;
          OpenBinary(dlgOpen.FileName, edRegisterImage, ref width, ref height ) ;
          if(ComDef.IsBitmapFileName(dlgOpen.FileName ) ){
            nuRegisterImageWidth .Value= width  ;
            nuRegisterImageHeight.Value= height ;
          }
          _wrkData.RegisterImage.FileName= dlgOpen.FileName ;
        }
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "C[Wf[^o^R}ht@Cǂݍ݃G[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^o^R}hf[^ʖۑ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void SaveAsRegisterImage()
    {
      try {
        byte[] data= GetRegisterImageByteData() ;
        dlgSave.FileName= _wrkData.RegisterImage.FileName ;
        dlgSave.Filter  = "C[Wf[^o^R}ht@C(*.dat)|*.dat" ;
        if(dlgSave.ShowDialog()== DialogResult.OK ){
          using(FileStream fs= new FileStream(dlgSave.FileName, FileMode.Create, FileAccess.Write ) ){
            fs.Write(data, 0, data.Length ) ;
            _wrkData.RegisterImage.FileName= dlgSave.FileName ;
          }
        }
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "C[Wf[^o^R}ht@C݃G[" ) ;
      }
    }
    # endregion

    # region 󎚃R}ht@C̓ǂݍ݂ƕۑ
    ///*************************************************************************************************
    /// <summary>
    /// 󎚃R}hf[^ǂݍ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void OpenPrintString()
    {
      try {
        dlgOpen.FileName= _wrkData.PrintString.FileName ;
        dlgOpen.Filter  = "󎚃R}ht@C(*.xml)|*.xml" ;
        if(dlgOpen.ShowDialog()== DialogResult.OK ){
          OpenXML(dlgOpen.FileName, edPrintString, cbPrintStringCRLF ) ;
          _wrkData.PrintString.FileName= dlgOpen.FileName ;
        }
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "󎚃R}ht@Cǂݍ݃G[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚃R}hf[^ʖۑ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void SaveAsPrintString()
    {
      try {
        dlgSave.FileName= _wrkData.PrintString.FileName ;
        dlgSave.Filter  = "󎚃R}ht@C(*.xml)|*.xml" ;
        if(dlgSave.ShowDialog()== DialogResult.OK ){
          SaveXML(dlgSave.FileName, edPrintString.Lines, cbPrintStringCRLF.Checked ) ;
          _wrkData.PrintString.FileName= dlgSave.FileName ;
        }
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "󎚃R}ht@C݃G[" ) ;
      }
    }
    # endregion

    # region C[W󎚃R}ht@C̓ǂݍ݂ƕۑ
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^󎚃R}hf[^ǂݍ
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2006/11/10 ( kw ) rbg}bvt@Cǂݍ߂悤ɕύXB
    /// </summary>
    private void OpenPrintImage()
    {
      try {
        dlgOpen.FileName= _wrkData.PrintImage.FileName ;
        dlgOpen.Filter  = "C[Wf[^(*.dat)|*.dat|rbg}bv(*.bmp)|*.bmp" ;
        if(ComDef.IsBitmapFileName(dlgOpen.FileName ) ){
          dlgOpen.FilterIndex= 2 ;
        }
        if(dlgOpen.ShowDialog()== DialogResult.OK ){
          int width = PrintImage._maxWidth ;
          int height= PrintImage._maxHeight;
          OpenBinary(dlgOpen.FileName, edPrintImage, ref width, ref height ) ;
          if(ComDef.IsBitmapFileName(dlgOpen.FileName ) ){
            nuPrintImageWidth .Value= width ;
            nuPrintImageHeight.Value= height;
          }
          _wrkData.PrintImage.FileName= dlgOpen.FileName ;
        }
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "C[Wf[^󎚃R}ht@Cǂݍ݃G[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^󎚃R}hf[^ʖۑ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void SaveAsPrintImage()
    {
      try {
        byte[] data= GetPrintImageByteData() ;
        dlgSave.FileName= _wrkData.PrintImage.FileName ;
        dlgSave.Filter  = "C[Wf[^󎚃R}ht@C(*.dat)|*.dat" ;
        if(dlgSave.ShowDialog()== DialogResult.OK ){
          using(FileStream fs= new FileStream(dlgSave.FileName, FileMode.Create, FileAccess.Write ) ){
            fs.Write(data, 0, data.Length ) ;
            _wrkData.PrintImage.FileName= dlgSave.FileName ;
          }
        }
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "C[Wf[^󎚃R}ht@C݃G[" ) ;
      }
    }
    # endregion

    ///*************************************************************************************************
    /// <summary>
    /// ŗ^ꂽrbg}bvt@CJATCY𒲐ăoCif[^ɕϊ
    /// L
    ///   (1) RGB(255,25,255)𖳎
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="fileName"></param>
    /// <param name="width"></param>
    /// <param name="height"></param>
    /// <returns></returns>
    private byte[] GetImageData(string fileName, ref int width, ref int height )
    {
      byte[] rc= null ; // return code of this proc
      //
      using(Bitmap bm= (Bitmap)Bitmap.FromFile(fileName ) ){
        width = (bm.Width > width  )? width : bm.Width  ;
        height= (bm.Height> height )? height: bm.Height ;
        int xcnt= ((width- 1 )/ 8 )+ 1 ;
        int ycnt= height ;
        rc= new byte[xcnt* ycnt ] ;
        for(int y= 0; y< height; y++ ){
          for(int x= 0; x< width; x++ ){
            Color cl= bm.GetPixel(x, y ) ;
            if((cl.R!= 255 )&& (cl.G!= 255 )&& (cl.B!= 255 ) ) {
              int pos= x/ 8+ y* xcnt ;
              int p= 1<< (7- x% 8 ) ;
              rc[pos ]= (byte)(rc[pos ]| p ) ;
            }
          }
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// eLXg{bNX̕f[^OXML`f[^ƂĕۑitȂj
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="fileName"></param>
    /// <param name="strs"></param>
    private void SaveXML(string fileName, string[] strs )
    {
      WriteData wd= new WriteData() ;
      wd._strings= new List<string>( strs ) ;
      //
      XmlSerializer xs= new XmlSerializer(typeof(WriteData) ) ;
      using(FileStream fs= new FileStream(fileName, FileMode.Create ) ){
        xs.Serialize(fs, wd ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// eLXg{bNX̕f[^OXML`f[^Ƃĕۑit񂠂j
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="fileName"></param>
    /// <param name="strs"></param>
    /// <param name="flg"></param>
    private void SaveXML(string fileName, string[] strs, bool flg )
    {
      WriteData wd= new WriteData() ;
      wd._strings= new List<string>( strs ) ;
      wd._hex    = flg ;
      //
      XmlSerializer xs= new XmlSerializer(typeof(WriteData) ) ;
      using(FileStream fs= new FileStream(fileName, FileMode.Create ) ){
        xs.Serialize(fs, wd ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// OXMLf[^AeLXg{bNX̕f[^ǂݍށitȂj
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="fileName"></param>
    /// <param name="textBox"></param>
    private void OpenXML(string fileName, TextBox textBox )
    {
      XmlSerializer xs=new XmlSerializer(typeof(WriteData ) ) ;
      WriteData wd ;
      using(FileStream fs= new FileStream(fileName, FileMode.Open ) ){
        wd= (WriteData)xs.Deserialize( fs ) ;
      }
      textBox.Lines = wd._strings.ToArray() ;
    }

    /// <summary>
    /// OXMLf[^AeLXg{bNX̕f[^ǂݍށitȂj
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  
    /// </remarks>
    /// <param name="fileName"></param>
    /// <param name="textBox1"></param>
    /// <param name="textBox2"></param>
    /// <param name="textBox3"></param>
    private void OpenXML( string fileName,
                          TextBox textBox1,
                          TextBox textBox2,
                          TextBox textBox3 )
    {
      XmlSerializer xs = new XmlSerializer( typeof( WriteData ) );
      WriteData wd;

      using( FileStream fs = new FileStream( fileName,
                                             FileMode.Open ) )
      {
        wd = (WriteData)xs.Deserialize( fs );
      }
      textBox1.Text = wd._strings[ 0 ].ToString();
      textBox2.Text = wd._strings[ 1 ].ToString();
      textBox3.Text = wd._strings[ 2 ].ToString();
    }

    ///*************************************************************************************************
    /// <summary>
    /// OXMLf[^AeLXg{bNX̕f[^ǂݍށit񂠂j
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="fileName"></param>
    /// <param name="textBox"></param>
    /// <param name="checkBox"></param>
    private void OpenXML(string fileName, TextBox textBox, CheckBox checkBox )
    {
      XmlSerializer xs=new XmlSerializer(typeof(WriteData ) ) ;
      WriteData wd ;
      using(FileStream fs= new FileStream(fileName, FileMode.Open ) ){
        wd= (WriteData)xs.Deserialize( fs ) ;
      }
      textBox.Lines   = wd._strings.ToArray() ;
      checkBox.Checked= wd._hex ;
    }

    /// <summary>
    /// OXMLf[^AeLXg{bNX̕f[^ǂݍށit񂠂j
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  
    /// </remarks>
    /// <param name="fileName"></param>
    /// <param name="textBox1"></param>
    /// <param name="textBox2"></param>
    /// <param name="textBox3"></param>
    /// <param name="checkBox"></param>
    private void OpenXML( string fileName,
                          TextBox textBox1,
                          TextBox textBox2,
                          TextBox textBox3,
                          CheckBox checkBox )
    {
      XmlSerializer xs = new XmlSerializer( typeof( WriteData ) );
      WriteData wd;

      using( FileStream fs = new FileStream( fileName,
                                             FileMode.Open ) )
      {
        wd = (WriteData)xs.Deserialize( fs );
      }
      textBox1.Text = wd._strings[ 0 ].ToString();
      textBox2.Text = wd._strings[ 1 ].ToString();
      textBox3.Text = wd._strings[ 2 ].ToString();
      checkBox.Checked = wd._hex;
    }

    ///*************************************************************************************************
    /// <summary>
    /// oCit@CJāAeLXg{bNXɓǂݍ
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="fileName"></param>
    /// <param name="textBox"></param>
    /// <param name="width"></param>
    /// <param name="height"></param>
    private void OpenBinary(string fileName, TextBox textBox, ref int width, ref int height )
    {
      byte[] data= null ;
      //
      if(ComDef.IsBitmapFileName(fileName ) ){
        // rbg}bvt@C
        data= GetImageData(fileName, ref width, ref height ) ;
      }else {
        // oCit@C
        using(FileStream fs= new FileStream(fileName, FileMode.Open, FileAccess.Read ) ){
          data=new byte[fs.Length];
          if(data.Length!=0) {
            fs.Read(data, 0, data.Length);
          }
        }
      }
      textBox.Lines= ComDef.ToHexStringsFromBinary( data ) ;
    }

    # region RWControl̃R}hĂяo
    ///*************************************************************************************************
    /// <summary>
    /// CjVR}hiblcPOjsiOȂj
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="res"></param>
    /// <returns></returns>
    private byte[] DoInitialize(ref V31Response res )
    {
      byte[] rc= null ; // return code of this proc
      //
      Initialize para= _wrkData.Initialize ;
      ROUT(string.Format("Jn Initialize({0})", para ) ) ;
      _rwControl.Timeout  = (int)nuTimeout  .Value ;
      _rwControl.RetryTime= (int)nuRetryTime.Value ;
      rc= _rwControl.Initialize(ref res, para.IniMode, para.RspMode ) ;
      ShowResponse( res ) ;
      ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// [hR}hiblcRRjsiOȂj
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="res"></param>
    /// <returns></returns>
    private byte[] DoRead(ref V31Response res )
    {
      byte[] rc= null ; // return code of this proc
      //
      Read para= _wrkData.Read ;
      ROUT(string.Format("Jn Read({0})", para ) ) ;
      _rwControl.Timeout  = (int)nuTimeout  .Value ;
      _rwControl.RetryTime= (int)nuRetryTime.Value ;
      rc= _rwControl.Read(ref res, para.Mode, para.Check, para.Track) ;
      ShowResponse( res ) ;
      ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// LZR}hiblcSOjsiOȂj
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="res"></param>
    /// <returns></returns>
    private byte[] DoCancel(ref V31Response res )
    {
      byte[] rc= null ; // return ocde of this proc
      //
      ROUT("Jn Cancel()" ) ;
      _rwControl.Timeout  = (int)nuTimeout  .Value ;
      _rwControl.RetryTime= (int)nuRetryTime.Value ;
      rc= _rwControl.Cancel(ref res ) ;
      ShowResponse( res ) ;
      ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// CgR}hiblcTRjsiOȂj
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// @2009/09/02 ( kw ) ϒf[^ɍ킹ăf[^쐬ł悤ɂ
    /// </summary>
    /// <param name="res"></param>
    /// <returns></returns>
    private byte[] DoWrite(ref V31Response res )
    {
      byte[] rc= null ; // return code of this proc
      //
      ROUT(string.Format("Jn Write({0})", _wrkData.Write )  ) ;
      _rwControl.Timeout  = (int)nuTimeout  .Value ;
      _rwControl.RetryTime= (int)nuRetryTime.Value ;
      byte[] uData= GetWriteByteData() ;
      byte[] data = new byte[_wrkData.Write.GetNecessaryBytes( uData.Length ) ] ;
      if(uData.Length!= 0 ){
        Array.Copy(uData, data, (uData.Length< data.Length )? uData.Length: data.Length ) ;
      }
      rc= _rwControl.Write(ref res, _wrkData.Write.Mode, _wrkData.Write.Check, _wrkData.Write.Track, data ) ;
      ShowResponse( res ) ;
      ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚃R}hiblcVbjsiOȂj
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="res"></param>
    /// <returns></returns>
    private byte[] DoPrintString(ref V31Response res )
    {
      byte[] rc= null ; // return code of this proc
      //
      ROUT(string.Format("Jn PrintString({0})", _wrkData.PrintString )  ) ;
      _rwControl.Timeout  = (int)nuTimeout  .Value ;
      _rwControl.RetryTime= (int)nuRetryTime.Value ;
      byte[] data= GetPrintStringByteData() ;
      rc= _rwControl.PrintString(ref res, _wrkData.PrintString.Mode, _wrkData.PrintString.Clear, _wrkData.PrintString.Line, data ) ;
      ShowResponse( res ) ;
      ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// J[hroR}hiblcWOjsiOȂj
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="res"></param>
    /// <returns></returns>
    private byte[] DoEject(ref V31Response res )
    {
      byte[] rc= null ; // reurn code of this proc
      //
      ROUT("Jn Eject()" ) ;
      _rwControl.Timeout  = (int)nuTimeout  .Value ;
      _rwControl.RetryTime= (int)nuRetryTime.Value ;
      rc= _rwControl.Eject(ref res ) ;
      ShowResponse( res ) ;
      ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// X|XđvsiOȂj
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="res"></param>
    /// <returns></returns>
    private byte[] DoGetResponse(ref V31Response res )
    {
      byte[] rc= null ; // return code of this proc
      ///
      ROUT("Jn GetResponse()" ) ;
      _rwControl.Timeout  = (int)nuTimeout  .Value ;
      _rwControl.RetryTime= (int)nuRetryTime.Value ;
      rc= _rwControl.GetResponse(ref res ) ;
      ShowResponse( res ) ;
      if(res.DataLength== 0 )  ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ) ) ;
      else {
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      return rc ;
    } 

    /// <summary>
    /// CgR}hiblcTRjsiOȂj
    /// </summary>
    /// <remarks>
    /// L
    ///   ISOlCgp
    /// ύX
    ///   2014/10/23  ( k.kondo )  
    /// </remarks>
    /// <param name="res"></param>
    /// <returns></returns>
    private byte[] DoISOWrite( ref V31Response res )
    {
      byte[] ret = null;
      byte[] tr1 = null;
      byte[] tr2 = null;
      byte[] tr3 = null;
      byte[] wrt1 = new byte[ ISOWrite.MAX_TRACK1_SZ ];
      byte[] wrt2 = new byte[ ISOWrite.MAX_TRACK2_SZ ];
      byte[] wrt3 = new byte[ ISOWrite.MAX_TRACK3_SZ ];
      int trlen1 = (int)0;
      int trlen2 = (int)0;
      int trlen3 = (int)0;

      ROUT( string.Format( "Jn Write({0})",
                           _wrkData.ISOWrite ) );
      _rwControl.Timeout = (int)nuTimeout.Value;
      _rwControl.RetryTime = (int)nuRetryTime.Value;
      //gbN1Cf[^
      if( chWriteTrack1.Checked )
      {
        tr1 = GetISOWriteByteDataTrack1();  //tbWriteTrack1eLXg{bNX玥Cf[^()擾
        if( tr1 != null )
        {
          //gbN1Cf[^擾
          trlen1 = _wrkData.ISOWrite.GetNecessaryBytesTrack1( tr1.Length );
          if( trlen1 > 0 )
          {
            Buffer.BlockCopy( tr1, 0, wrt1, 0, trlen1 );
          }
        }
      }
      //gbN2Cf[^
      if( chWriteTrack2.Checked )
      {
        tr2 = GetISOWriteByteDataTrack2();  //tbWriteTrack2eLXg{bNX玥Cf[^()擾
        if( tr2 != null )
        {
          //gbN2Cf[^擾
          trlen2 = _wrkData.ISOWrite.GetNecessaryBytesTrack2( tr2.Length );
          if( trlen2 > 0 )
          {
            Buffer.BlockCopy( tr2, 0, wrt2, 0, trlen2 );
          }
        }
      }
      //gbN3Cf[^
      if( chWriteTrack3.Checked )
      {
        tr3 = GetISOWriteByteDataTrack3();  //tbWriteTrack3eLXg{bNX玥Cf[^()擾
        if( tr3 != null )
        {
          //gbN3Cf[^擾
          trlen3 = _wrkData.ISOWrite.GetNecessaryBytesTrack3( tr3.Length );
          if( trlen3 > 0 )
          {
            Buffer.BlockCopy( tr3, 0, wrt3, 0, trlen3 );
          }
        }
      }
      //CgR}hs
      ret = _rwControl.WriteForISO( ref res,
                                    _wrkData.ISOWrite.Track,
                                    (ushort)trlen1,
                                    wrt1,
                                    (ushort)trlen2,
                                    wrt2,
                                    (ushort)trlen3,
                                    wrt3 );
      ShowResponse( res );
      ROUT( string.Format( _fmtEndstatus,
                           res.RPS1,
                           res.RPS2,
                           res.RPS3 ),
            ret );

      return ( ret );
    }

    # endregion

    ///*************************************************************************************************
    /// <summary>
    /// CjVR}hiblcPOjs
    /// ύX
    ///   2006/10/25 ( kw ) 
    ///   2006/11/10 ( kw ) sDoInitialize()Ƃĕ
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btInitialize_Click(object sender, EventArgs e)
    {
      ImportInitialize() ;
      V31Response res= null ;
      try {
        DoInitialize( ref res ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "CjVR}hsG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Xe[^X[hR}hiblcQOjs
    /// ύX
    ///   2006/10/25 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btStatusRead_Click(object sender, EventArgs e)
    {
      V31Response res= null ;
      try {
        ROUT("Jn StatusRead()" ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] rc= _rwControl.StatusRead(ref res ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "Xe[^X[hsG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// ZT擾R}hiblcQPjs
    /// ύX
    ///   2009/06/24 ( kw ) 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btGetSensorStatus_Click(object sender, EventArgs e)
    {
      bool sensor1= false ;
      bool sensor2= false ;
      bool sensor3= false ;
      bool sensor4= false ;
      bool sensor5= false ;
      V31Response res= null ;
      try {
        _rwControl.Timeout  = (int)nuTimeout.Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        ROUT("Jn GetSensorStatus()" ) ;
        byte[] rc= _rwControl.GetSensorStatus(ref res, ref sensor1, ref sensor2, ref sensor3, ref sensor4, ref sensor5 ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(
               "I [RPS1=0x{0:X2}, RPS2=0x{1:X2}, 0xRPS3=0x{2:X2}] ZT#1={3},ZT#2={4},ZT#3={5},ZT#4={6},ZT#5={7}"
               , res.RPS1
               , res.RPS2
               , res.RPS3
               , ((sensor1 )? "ON": "OFF")
               , ((sensor2 )? "ON": "OFF")
               , ((sensor3 )? "ON": "OFF")
               , ((sensor4 )? "ON": "OFF")
               , ((sensor5 )? "ON": "OFF") ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "ZT擾sG[" ) ; 
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// [hR}hiblcRRjs
    /// ύX
    ///   2006/10/25 ( kw ) 
    ///   2006/11/10 ( kw ) sDoRead()Ƃĕ
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btRead_Click(object sender, EventArgs e)
    {
      ImportRead() ;
      V31Response res= null ;
      try {
        DoRead( ref res ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "[hR}hsG[" ) ; 
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// LZR}hiblcSOjs
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2006/11/10 ( kw ) sDoCancel()Ƃĕ
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btCancel_Click(object sender, EventArgs e)
    {
      SetDataFromControls() ;
      V31Response res= null ;
      try {
        DoCancel( ref res ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "LZsG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// CgR}hiblcTRjs
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2006/11/10 ( kw ) sDoWrite()Ƃĕ
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btWrite_Click(object sender, EventArgs e)
    {
      ImportWrite() ;
      V31Response res= null ;
      try {
        DoWrite( ref res ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "CgR}hsG[");
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Oo^R}hiblcVUjs
    /// ύX
    ///  2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btRegisterGaiji_Click(object sender, EventArgs e)
    {
      ImportRegisterGaiji() ;
      V31Response res= null ;
      try {
        ROUT(string.Format("Jn RegisterGaiji({0})", _wrkData.RegisterGaiji )  ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] data = new byte[_wrkData.RegisterGaiji.GetNecessaryBytes() ] ;
        byte[] uData= GetRegisterGaijiByteData() ;
        if(uData.Length!= 0 ){
          Array.Copy(uData, data, (uData.Length< data.Length )? uData.Length: data.Length ) ;
        }
        byte[] rc= _rwControl.RegisterGaiji(ref res, _wrkData.RegisterGaiji.No, _wrkData.RegisterGaiji.Size, data ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "Oo^sG[" ) ; 
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wo^R}hiblcVVjs
    /// ύX
    ///   2006/10/26 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btRegisterImage_Click(object sender, EventArgs e)
    {
      ImportRegisterImage() ;
      V31Response res= null ;
      try {
        ROUT(string.Format("Jn RegisterImage({0})", _wrkData.RegisterImage )  ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] data = new byte[_wrkData.RegisterImage.GetNecessaryBytes() ] ;
        byte[] uData= GetRegisterImageByteData() ;
        if(uData.Length!= 0 ){
          Array.Copy(uData, data, (uData.Length< data.Length )? uData.Length: data.Length ) ;
        }
        byte[] rc= _rwControl.RegisterImage(ref res, _wrkData.RegisterImage.Address, _wrkData.RegisterImage.Width, _wrkData.RegisterImage.Height, data ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "C[Wo^sG[" ) ; 
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚐ݒR}hiblcVWjs
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btPrintSetting_Click(object sender, EventArgs e)
    {
      ImportPrintSetting() ;
      V31Response res= null ;
      try {
        ROUT(string.Format("Jn PrintSetting({0})", _wrkData.PrintSetting )  ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] rc= _rwControl.PrintSetting(ref res, _wrkData.PrintSetting.Card, _wrkData.PrintSetting.Mode, _wrkData.PrintSetting.Align, _wrkData.PrintSetting.Font ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "󎚐ݒR}hsG["); 
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^󎚃R}hiblcVajs
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btPrintImage_Click(object sender, EventArgs e)
    {
      ImportPrintImage() ;
      V31Response res= null ;
      try {
        ROUT(string.Format("Jn PrintImage({0})", _wrkData.PrintImage )  ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] rc= null ;
        if(_wrkData.PrintImage.ByAddress ){
          // AhXwiC[Wf[^󎚁j
          rc= _rwControl.PrintImage(ref res
                           , _wrkData.PrintImage.Mode
                           , _wrkData.PrintImage.Clear
                           , _wrkData.PrintImage.Width
                           , _wrkData.PrintImage.Height
                           , _wrkData.PrintImage.X
                           , _wrkData.PrintImage.Y
                           , _wrkData.PrintImage.Address
                         ) ;
        }else {
          // C[Wf[^wiC[Wf[^󎚁j
          byte[] data= GetPrintImageByteData() ;
          rc= _rwControl.PrintImage(ref res
                           , _wrkData.PrintImage.Mode
                           , _wrkData.PrintImage.Clear
                           , _wrkData.PrintImage.Width
                           , _wrkData.PrintImage.Height
                           , _wrkData.PrintImage.X
                           , _wrkData.PrintImage.Y
                           , data
                         ) ;
        }
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "C[Wf[^󎚃R}hsG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚃R}hiblcVbjs
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2006/11/10 ( kw ) sDoPrintString()Ƃĕ
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btPrintString_Click(object sender, EventArgs e)
    {
      ImportPrintString() ;
      V31Response res= null ;
      try {
        DoPrintString( ref res ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "󎚃R}hsG[" ) ;
      }
    }
    ///**************************************************************************************************
    /// <summary>
    /// o[R[h󎚃R}hiblcjs
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btPrintBarcode_Click(object sender, EventArgs e)
    {
      ImportPrintBarcode() ;
      V31Response res= null ;
      try {
        ROUT(string.Format("Jn PrintBarcode({0})", _wrkData.PrintBarcode )  ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] data= ComDef.ToBinaryFromString( _wrkData.PrintBarcode.Data ) ;
        byte[] rc= _rwControl.PrintBarcode(ref res, _wrkData.PrintBarcode.Mode, _wrkData.PrintBarcode.Clear, _wrkData.PrintBarcode.Kind, _wrkData.PrintBarcode.Tip, _wrkData.PrintBarcode.Width, _wrkData.PrintBarcode.Height, _wrkData.PrintBarcode.X, _wrkData.PrintBarcode.Y, data ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "o[R[h󎚃R}hsG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// J[hroR}hiblcWOjs
    ///   2006/11/10 ( kw ) sDoEject()Ƃĕ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btEject_Click(object sender, EventArgs e)
    {
      V31Response res= null ;
      try {
        DoEject( ref res ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "J[hrosG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// N[jOR}hiblcjs
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btCleaning_Click(object sender, EventArgs e)
    {
      V31Response res= null ;
      try {
        ROUT("Jn Cleaning()" ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] rc= _rwControl.Cleaning(ref res ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "N[jOsG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// vݒR}hiblcdPjs
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btSetClock_Click(object sender, EventArgs e)
    {
      V31Response res= null ;
      try {
        DateTime dt= DateTime.Now ;
        ROUT(string.Format("Jn SetClock(dt={0})", dt ) ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] rc= _rwControl.SetClock(ref res, dt ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "vݒsG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// o[W擾R}hiblceOjs
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btGetVersion_Click(object sender, EventArgs e)
    {
      V31Response res= null ;
      try {
        ROUT("Jn GetVersion()" ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] rc= _rwControl.GetVersion(ref res ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "o[W擾sG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// ݎ擾R}hiblcePjs
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btGetClock_Click(object sender, EventArgs e)
    {
      V31Response res= null ;
      DateTime   dt = new DateTime() ;
      try {
        ROUT("Jn GetClock()" ) ;
        _rwControl.Timeout  = (int)nuTimeout  .Value ;
        _rwControl.RetryTime= (int)nuRetryTime.Value ;
        byte[] rc= _rwControl.GetClock(ref res, ref dt ) ;
        ShowResponse( res ) ;
        ROUT(string.Format(_fmtEndstatus, res.RPS1, res.RPS2, res.RPS3 ), rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "ݎ擾sG[" ) ; 
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// X|Xđvs
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2006/11/10 ( kw ) sDoGetResponse()Ƃĕ
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btGetResponse_Click(object sender, EventArgs e)
    {
      V31Response res= null ;
      try {
        DoGetResponse( ref res ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "X|XđG[" ) ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// fs
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btStartDemo_Click(object sender, EventArgs e)
    {
      btStartDemo.Enabled= false ; // fs{^𖳌
      SetContols(pnCntl, false ) ;
      SetContols(tbDemo, false ) ;
      byte[] rc= null ;
      try {
        //----------------------------------------------------------------------------------------------
        //  uRPڑmF
        //----------------------------------------------------------------------------------------------
        if(!_rwControl.IsOpen ) throw new InvalidOperationException("ʐMfoCXJĂ܂" ) ;
        else {
          _rwControl.Close() ;
          _rwControl.LockEvents= false ;
          _rwControl.Open () ;
        }
        int cnt= 0 ;
        if(_rwControl== _comControl ){
          ROUT("V31ڑmFc" ) ;
          while(!_comControl.CTS) {
            Thread.Sleep(100);
            if(++cnt> 10 ) throw new TimeoutException("V31ڑĂ܂");
          }
        }
        //----------------------------------------------------------------------------------------------
        //  uRP
        //----------------------------------------------------------------------------------------------
        V31Response res= null ;
        cnt= 0 ;
        ROUT( "c" ) ;
        rc= DoInitialize(ref res ) ;
        do {
          if(res.RPS3== 0x32 ) throw new InvalidOperationException("Ɏs܂" ) ;
          Thread.Sleep( 250 ) ;
          if(++cnt> 40 ) throw new TimeoutException("̃^CAEgł" ) ;
          rc= DoGetResponse( ref res ) ;
        }while( res.RPS3!= 0x30 ) ;
        ROUT("", rc ) ;
        //----------------------------------------------------------------------------------------------
        //  J[hǂݍ݁iJ[h}҂j
        //----------------------------------------------------------------------------------------------
        ROUT("J[h[hc" ) ;
        rc= DoRead(ref res ) ;
        btCancelDemo.Enabled= true ;
        btCancelDemo.Focus() ;
        do {
          if(res.RPS3== 0x32|| res.RPS2!= 0x30 ) throw new InvalidOperationException("J[h[hɎs܂                   xz" ) ;
          Thread.Sleep(250);
          if(!btCancelDemo.Enabled ){
            rc= DoCancel(ref res ) ;
            throw new UserBreakException() ;
          }else {
            rc= DoGetResponse(ref res);
          }  
        } while(res.RPS3!= 0x30 ) ;
        btCancelDemo.Enabled= false ;
        //----------------------------------------------------------------------------------------------
        //  CXV
        //----------------------------------------------------------------------------------------------
        ROUT("CXVc" ) ;
        rc= DoWrite(ref res ) ;
        do {
          if(res.RPS3== 0x32 ) throw new InvalidOperationException("CXVɎs܂" ) ;
          Thread.Sleep( 250 ) ;
          rc= DoGetResponse( ref res ) ;
        }while( res.RPS3!= 0x30 ) ;

        ROUT("󎚏c" ) ;
        rc= DoPrintString(ref res ) ;
        do {
          if(res.RPS3== 0x32 ) throw new InvalidOperationException("󎚏Ɏs܂" ) ;
          Thread.Sleep( 250 ) ;
          rc= DoGetResponse( ref res ) ;
        }while( res.RPS3!= 0x30 ) ;
        //----------------------------------------------------------------------------------------------
        //  J[hro
        //----------------------------------------------------------------------------------------------
        ROUT("J[hroc" ) ;
        DoEject(ref res ) ;
      }
      catch(UserBreakException ){
        ROUT("[U[vɂ~", rc ) ;
      }
      catch(Exception ex ){
        ComDef.EMbxOk(ex.Message, "fsG[" ) ;
      }
      finally {
        bool bOpen= _rwControl.IsOpen ;
        if(bOpen ) _rwControl.Close() ;
        _rwControl.LockEvents= true ;
        if(bOpen ) _rwControl.Open() ;
      }
      SetContols(pnCntl, true ) ;
      SetContols(tbDemo, true ) ;
      btCancelDemo.Enabled= false ;
      btStartDemo .Enabled= true  ;
      RefreshControls(sender, e ) ;
    }

    /// <summary>
    /// CgR}hiblcTRjs
    /// </summary>
    /// <remarks>
    /// L
    ///   ISOlCg
    /// ύX
    ///   2014/10/23  (k.kondo)  
    /// </remarks>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btnISOWrite_Click( object sender, EventArgs e )
    {
      V31Response res = null;

      ImportISOWrite();
      try
      {
        DoISOWrite( ref res );
      }
      catch( Exception ex )
      {
        ComDef.EMbxOk( ex.Message,
                       "CgR}hsG[" );
      }
    }

    private void SetContols(Control owner, bool flg )
    {
      foreach(Control c in owner.Controls ){
        if( (c is ComboBox      )
          ||(c is NumericUpDown )
          ||(c is Button        ) 
          ||(c is TextBox       ) ){
          c.Enabled= flg ;
        }
      }

    }
    ///*************************************************************************************************
    /// <summary>
    /// Avf[^̐ݒlʏ̊eRg[ɔf
    /// L
    ///   (1) {֐̓AvNɈxĂ΂
    /// ύX
    ///   2006/10/25 ( kw ) 
    ///   2006/11/10 ( kw ) f[^t@C̓ǂݍݏǉ
    ///   2014/10/23  (k.kondo)  ISOlCgp[^ǉ
    /// </summary>
    void SetControlsFromData()
    {
      Left= _wrkData.Left;
      Top = _wrkData.Top ;
      //
      // ʐMݒp[^
      _wrkData.CommPort.Export(cbPortName, cbBaudRate, cbParity, cbStopBits, nuTimeout, nuRetryTime ) ;
      // CjVR}hp[^
      _wrkData.Initialize.Export(cbIniMode, cbRspMode ) ;
      // [hR}hp[^
      _wrkData.Read.Export(cbReadMode, cbReadCheck, cbReadTrack ) ;
      //
      // Cgp[^
      _wrkData.Write.Export(
          cbWriteMode
        , cbWriteCheck
        , cbWriteTrack
      ) ;
      if(File.Exists(_wrkData.Write.FileName ) ){
        OpenXML(_wrkData.Write.FileName, edWrite, cbWriteHex ) ;
      }
      //
      // Oo^p[^
      _wrkData.RegisterGaiji.Export(
          nuGaijiNo
        , cbGaijiSize
      ) ;
      if(File.Exists(_wrkData.RegisterGaiji.FileName ) ){
        int  width = RegisterGaiji._maxWidth ;
        int  height= RegisterGaiji._maxHeight;
        OpenBinary(_wrkData.RegisterGaiji.FileName, edRegisterGaiji, ref width, ref height ) ; 
      }
      //
      // C[Wo^p[^
      _wrkData.RegisterImage.Export(
          nuRegisterImageAddress
        , nuRegisterImageWidth
        , nuRegisterImageHeight
      ) ;
      if(File.Exists(_wrkData.RegisterImage.FileName ) ){
        int  width = RegisterImage._maxWidth ;
        int  height= RegisterImage._maxHeight;
        OpenBinary(_wrkData.RegisterImage.FileName, edRegisterImage, ref width, ref height ) ; 
        if(ComDef.IsBitmapFileName( _wrkData.RegisterImage.FileName ) ){
          nuRegisterImageWidth .Value= width ;
          nuRegisterImageHeight.Value= height ;
        }
      }
      // 󎚐ݒp[^
      _wrkData.PrintSetting.Export(cbPrintSettingCard, cbPrintSettingMode, cbPrintSettingAlign, cbPrintSettingFont ) ;
      // C[Wf[^󎚃p[^
      _wrkData.PrintImage.Export(
          cbPrintImageMode
        , cbPrintImageClear
        , nuPrintImageWidth
        , nuPrintImageHeight
        , nuPrintImageX
        , nuPrintImageY
        , nuPrintImageAddress
        , cbPrintImageByAddress
      ) ;
      if(File.Exists(_wrkData.PrintImage.FileName ) ){
        int width = PrintImage._maxWidth  ;
        int height= PrintImage._maxHeight ;
        OpenBinary(_wrkData.PrintImage.FileName, edPrintImage, ref width, ref height ) ;
        if(ComDef.IsBitmapFileName( _wrkData.PrintImage.FileName ) ){
          nuPrintImageWidth.Value = width  ;
          nuPrintImageHeight.Value= height ;
        }
      }
      // 󎚃p[^
      _wrkData.PrintString.Export(
          cbPrintStringMode
        , cbPrintStringClear
        , nuPrintStringLine
      ) ;
      if(File.Exists(_wrkData.PrintString.FileName ) ){
        OpenXML(_wrkData.PrintString.FileName, edPrintString, cbPrintStringCRLF ) ;
      }
      // o[R[h󎚃p[^
      _wrkData.PrintBarcode.Export(cbPrintBarcodeMode, cbPrintBarcodeClear, cbPrintBarcodeKind, cbPrintBarcodeTip, cbPrintBarcodeWidth, nuPrintBarcodeHeight, nuPrintBarcodeX, nuPrintBarcodeY, edPrintBarcodeData ) ;

      //ISOlCgp[^
      _wrkData.ISOWrite.Export( cbISOWriteTrack );
      if( File.Exists(_wrkData.ISOWrite.FileName ) )
      {
        OpenXML( _wrkData.ISOWrite.FileName,
                 tbWriteTrack1,
                 tbWriteTrack2,
                 tbWriteTrack3,
                 chISOWriteHex );
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// ʏ̊eRg[̐ݒlAvf[^ɓ]L
    /// ύX
    ///   2006/10/25 ( kw ) 
    ///   2014/10/23  (k.kondo)  ImportISOWrite()ǉ
    /// </summary>
    void SetDataFromControls()
    {
      _wrkData.Left= Left;
      _wrkData.Top = Top ;
      ImportCommPort     () ; // ʐMݒp[^
      ImportInitialize   () ; // CjVR}hp[^
      ImportRead         () ; // [hR}hp[^
      ImportWrite        () ; // CgR}hp[^
      ImportRegisterGaiji() ; // Oo^R}hp[^
      ImportRegisterImage() ; // C[Wf[^o^R}hp[^
      ImportPrintSetting () ; // 󎚐ݒR}hp[^
      ImportPrintImage   () ; // C[Wf[^󎚃R}hp[^
      ImportPrintString  () ; // 󎚃R}hp[^
      ImportPrintBarcode () ; // o[R[h󎚃R}hp[^
      ImportISOWrite();  //CgR}h(ISOl)p[^
    }

    #   region eRg[R}hp[^ւ̃f[^]L
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒʐMݒp[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void ImportCommPort()
    {
      _wrkData.CommPort.Import(cbPortName, cbBaudRate, cbParity, cbStopBits, nuTimeout, nuRetryTime ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒCjVR}hp[^p[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void ImportInitialize()
    {
      _wrkData.Initialize.Import(cbIniMode, cbRspMode ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒ[hR}hp[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void ImportRead()
    {
      _wrkData.Read.Import(cbReadMode, cbReadCheck, cbReadTrack ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒCgR}hp[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    void ImportWrite()
    {
      _wrkData.Write.Import(cbWriteMode, cbWriteCheck, cbWriteTrack ) ; // Cgp[^
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒOo^R}hp[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    void ImportRegisterGaiji()
    {
      _wrkData.RegisterGaiji.Import(nuGaijiNo, cbGaijiSize ) ; // Oo^p[^
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒC[Wf[^o^R}hp[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    void ImportRegisterImage()
    {
      _wrkData.RegisterImage.Import(nuRegisterImageAddress, nuRegisterImageWidth, nuRegisterImageHeight ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒ󎚐ݒR}hp[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    void ImportPrintSetting()
    {
      _wrkData.PrintSetting.Import(cbPrintSettingCard, cbPrintSettingMode, cbPrintSettingAlign, cbPrintSettingFont ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒC[Wf[^󎚃R}hp[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    void ImportPrintImage()
    {
      _wrkData.PrintImage.Import(cbPrintImageMode, cbPrintImageClear, nuPrintImageWidth, nuPrintImageHeight, nuPrintImageX, nuPrintImageY, nuPrintImageAddress, cbPrintImageByAddress ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒ𕶎󎚃R}hp[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    void ImportPrintString()
    {
      _wrkData.PrintString.Import(cbPrintStringMode, cbPrintStringClear, nuPrintStringLine ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒo[R[h󎚃R}hp[^ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    private void ImportPrintBarcode()
    {
      _wrkData.PrintBarcode.Import(cbPrintBarcodeMode, cbPrintBarcodeClear, cbPrintBarcodeKind, cbPrintBarcodeTip, cbPrintBarcodeWidth, nuPrintBarcodeHeight, nuPrintBarcodeX, nuPrintBarcodeY, edPrintBarcodeData ) ;
    }

    /// <summary>
    /// Rg[̐ݒCgR}h(ISOl)p[^ɔf
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    void ImportISOWrite()
    {
      _wrkData.ISOWrite.Import( cbISOWriteTrack );
    }
    #   endregion

    #   region eLXg{bNX̕AR}hŎgpoCif[^ɕϊ
    ///*************************************************************************************************
    /// <summary>
    /// eLXg{bNXŎw肵CgR}hpf[^oCif[^ɕϊ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    private byte[] GetWriteByteData()
    {
      byte[] rc= null ; // return code of this proc
      //
      if(cbWriteHex.Checked ) rc= ComDef.ToBinaryFromHexStrings( edWrite.Lines ) ;
      else                    rc= ComDef.ToBinaryFromStrings   ( edWrite.Lines ) ;
      return rc ;
    }

    /// <summary>
    /// tbWriteTrack1eLXg{bNXŎw肵CgR}hpf[^oCif[^ɕϊ
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    /// <returns></returns>
    private byte[] GetISOWriteByteDataTrack1()
    {
      byte[] ret = null;

      if( chISOWriteHex.Checked )
      {
        //16iw肠
        ret = ComDef.HexToBytes( tbWriteTrack1.Text );
      }
      else
      {
        //16iwȂ
        ret = ComDef.CharToBytes( tbWriteTrack1.Text );
      }

      return ( ret );
    }

    /// <summary>
    /// tbWriteTrack2eLXg{bNXŎw肵CgR}hpf[^oCif[^ɕϊ
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    /// <returns></returns>
    private byte[] GetISOWriteByteDataTrack2()
    {
      byte[] ret = null;

      if( chISOWriteHex.Checked )
      {
        //16iw肠
        ret = ComDef.HexToBytes( tbWriteTrack2.Text );
      }
      else
      {
        //16iwȂ
        ret = ComDef.CharToBytes( tbWriteTrack2.Text );
      }

      return ( ret );
    }

    /// <summary>
    /// tbWriteTrack3eLXg{bNXŎw肵CgR}hpf[^oCif[^ɕϊ
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    /// <returns></returns>
    private byte[] GetISOWriteByteDataTrack3()
    {
      byte[] ret = null;

      if( chISOWriteHex.Checked )
      {
        //16iw肠
        ret = ComDef.HexToBytes( tbWriteTrack3.Text );
      }
      else
      {
        //16iwȂ
        ret = ComDef.CharToBytes( tbWriteTrack3.Text );
      }

      return ( ret );
    }

    ///*************************************************************************************************
    /// <summary>
    /// eLXg{bNXŎw肵Oo^R}hpf[^oCif[^ɕϊ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    private byte[] GetRegisterGaijiByteData()
    {
      return ComDef.ToBinaryFromHexStrings( edRegisterGaiji.Lines ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// eLXg{bNXŎw肵C[Wf[^o^R}hpf[^oCif[^ɕϊ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    private byte[] GetRegisterImageByteData()
    {
      return ComDef.ToBinaryFromHexStrings( edRegisterImage.Lines ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// eLXg{bNXŎw肵󎚃R}hpf[^oCif[^ɕϊ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    private byte[] GetPrintStringByteData()
    {
      byte[] rc= new byte[0] ; // return code of this proc
      ///
      if(!cbPrintStringCRLF.Checked ){
        // sȂ
        rc= ComDef.ToBinaryFromStrings( edPrintString.Lines ) ;
      }else {
        string str= "" ;
        foreach(string s in edPrintString.Lines ){
          str+= (s+ "\r" ) ;
        }
        rc= ComDef.ToBinaryFromString( str ) ;
        ROUT( str, rc ) ;
      }
      if(rc.Length> 246 ){
        byte[] tmp= new byte[246 ] ;
        Array.Copy(rc, tmp, 246 ) ;
        rc= tmp ;
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// eLXg{bNXŎw肵C[Wf[^󎚃R}hpf[^oCif[^ɕϊ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    private byte[] GetPrintImageByteData()
    {
      return ComDef.ToBinaryFromHexStrings( edPrintImage.Lines ) ;
    }
    #   endregion

    ///*************************************************************************************************
    /// <summary>
    /// X|X𒲂ׂă[_C^̏Ԃ\
    /// ύX
    /// @2006/10/27 ( kw ) 
    ///   2006/11/10 ( kw ) sDoInitialize()Ƃĕ
    /// @2009/06/17 ( kw ) X|XV31ResponseNXɕύX
    /// @2009/06/24 ( kw ) Xe[^X𒷑qa̎dlɂ킹
    /// </summary>
    /// <param name="res"></param>
    private void ShowResponse(V31Response res)
    {
      switch( res.RPS1 ){
      case 0x30: lbRPS1.Text= "uJ[hȂ"  ; break ;
      case 0x31: lbRPS1.Text= "uJ[h"  ; break ; 
      case 0x32: lbRPS1.Text= "J[hԈُ"    ; break ;
      case 0x33: lbRPS1.Text= "uJ[hLQ"; break ;
      case 0x34: lbRPS1.Text= "}J[hc"  ; break ;
      }
      switch( res.RPS2 ){
      case 0x30: lbRPS2.Text= "G["                   ; break ;
      case 0x31: lbRPS2.Text= "[hG["                 ; break ;
      case 0x32: lbRPS2.Text= "CgG["                 ; break ;
      case 0x33: lbRPS2.Text= "J[hl܂G["           ; break ;
      case 0x35: lbRPS2.Text= "v^G["               ; break ;
      case 0x38: lbRPS2.Text= "sG["               ; break ;
      case 0x40: lbRPS2.Text= "drdቺx"             ; break ;
      case 0x41: lbRPS2.Text= "CԌx"                 ; break ;
      case 0x42: lbRPS2.Text= "Cf[^x"           ; break ;
      case 0x43: lbRPS2.Text= "T[}wbhhbg؂x" ; break ;
      case 0x51: lbRPS2.Text= "gbNP[hG["       ; break ;
      case 0x52: lbRPS2.Text= "gbNQ[hG["       ; break ;
      case 0x53: lbRPS2.Text= "gbNR[hG["       ; break ;
      case 0x54: lbRPS2.Text= "gbNPCQ[hG["   ; break ;
      case 0x55: lbRPS2.Text= "gbNPCR[hG["   ; break ;
      case 0x56: lbRPS2.Text= "gbNQCR[hG["   ; break ;
      }
      switch( res.RPS3 ){
      case 0x30: lbRPS3.Text= "R}hsI" ; break ;
      case 0x32: lbRPS3.Text= "R}hss" ; break ;
      case 0x33: lbRPS3.Text= "R}hs"   ; break ;
      case 0x34: lbRPS3.Text= "J[h}҂"   ; break ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// gpʐMRg[̑Is
    /// ύX
    /// @2009/06/17 ( kw ) 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void rbControl_CheckedChanged(object sender, EventArgs e)
    {
      if(     rbUSB   .Checked ) _rwControl= _usbControl ;
      else if(rbSerial.Checked ) _rwControl= _comControl ;
      RefreshControls(sender, e ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// J[h}҂ɂāA[U[fv󂯕t
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void btCancelDemo_Click(object sender, EventArgs e)
    {
      btCancelDemo.Enabled= false ;
    }

    #region  ISOlCgptbWriteTrackeLXg{bNX L[̓Cxg
    /// <summary>
    /// gbN1Cf[^peLXg{bNX L[vXCxg
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tbWriteTrack1_KeyPress( object sender, KeyPressEventArgs e )
    {
      //EnterL[
      ComDef.DisableKeyPress( e, Keys.Enter );
    }

    /// <summary>
    /// gbN2Cf[^peLXg{bNX L[vXCxg
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tbWriteTrack2_KeyPress( object sender, KeyPressEventArgs e )
    {
      //EnterL[
      ComDef.DisableKeyPress( e, Keys.Enter );
    }

    /// <summary>
    /// gbN3Cf[^peLXg{bNX L[vXCxg
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/23  (k.kondo)  ǉ
    /// </remarks>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tbWriteTrack3_KeyPress( object sender, KeyPressEventArgs e )
    {
      //EnterL[
      ComDef.DisableKeyPress( e, Keys.Enter );
    }
    #endregion  ISOlCgptbWriteTrackeLXg{bNX L[̓Cxg

    #region  ISOlCgpchWriteTrack`FbN{bNX `FbNCxg
    /// <summary>
    /// gbN1Cf[^p`FbN{bNX `FbNCxg
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/24  (k.kondo)  ǉ
    /// </remarks>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void chWriteTrack1_CheckedChanged( object sender, EventArgs e )
    {
      tbWriteTrack1.Enabled = chWriteTrack1.Checked;
    }

    /// <summary>
    /// gbN2Cf[^p`FbN{bNX `FbNCxg
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/24  (k.kondo)  ǉ
    /// </remarks>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void chWriteTrack2_CheckedChanged( object sender, EventArgs e )
    {
      tbWriteTrack2.Enabled = chWriteTrack2.Checked;
    }

    /// <summary>
    /// gbN3Cf[^p`FbN{bNX `FbNCxg
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/24  (k.kondo)  ǉ
    /// </remarks>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void chWriteTrack3_CheckedChanged( object sender, EventArgs e )
    {
      tbWriteTrack3.Enabled = chWriteTrack3.Checked;
    }
    #endregion  ISOlCgpchWriteTrack`FbN{bNX `FbNCxg

    #region  ISOlCgCf[^eLXg{bNXpToolTip
    private const string MSG_TOOLTIP_HEX = "31 32 33 EEE ̗lɎw肵Ă";
    private const string MSG_TOOLTIP_ASCII = "123ABC EEE ̗lɎw肵Ă";

    private ToolTip m_toolTip1;
    private ToolTip m_toolTip2;
    private ToolTip m_toolTip3;


    /// <summary>
    /// 16i`FbN{bNX `FbNCxg
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void chISOWriteHex_CheckedChanged( object sender, EventArgs e )
    {
      ApplyToolTip();
    }

    /// <summary>
    /// ToolTip
    /// <remarks>
    /// ύX
    ///   2014/10/24  (k.kondo)  ǉ
    /// </remarks>
    /// </summary>
    private void InitToolTip()
    {
      //
      m_toolTip1 = new ToolTip();
      m_toolTip1.InitialDelay = (int)100;  //ToolTip\܂ł̎
      m_toolTip1.ReshowDelay = (int)1000;  //ToolTip\Ă鎞ɁAʂToolTip\܂ł̎
      m_toolTip1.AutoPopDelay = (int)10000;  //ToolTip\鎞
      m_toolTip1.ShowAlways = true;  //tH[ANeBułȂłToolTip\
      m_toolTip1.SetToolTip( tbWriteTrack1, MSG_TOOLTIP_ASCII );  //ToolTip\
      //
      m_toolTip2 = new ToolTip();
      m_toolTip2.InitialDelay = (int)100;  //ToolTip\܂ł̎
      m_toolTip2.ReshowDelay = (int)1000;  //ToolTip\Ă鎞ɁAʂToolTip\܂ł̎
      m_toolTip2.AutoPopDelay = (int)10000;  //ToolTip\鎞
      m_toolTip2.ShowAlways = true;  //tH[ANeBułȂłToolTip\
      m_toolTip2.SetToolTip( tbWriteTrack2, MSG_TOOLTIP_ASCII );  //ToolTip\
      //
      m_toolTip3 = new ToolTip();
      m_toolTip3.InitialDelay = (int)100;  //ToolTip\܂ł̎
      m_toolTip3.ReshowDelay = (int)1000;  //ToolTip\Ă鎞ɁAʂToolTip\܂ł̎
      m_toolTip3.AutoPopDelay = (int)10000;  //ToolTip\鎞
      m_toolTip3.ShowAlways = true;  //tH[ANeBułȂłToolTip\
      m_toolTip3.SetToolTip( tbWriteTrack3, MSG_TOOLTIP_ASCII );  //ToolTip\
    }

    /// <summary>
    /// ToolTip\
    /// </summary>
    /// <remarks>
    /// ύX
    ///   2014/10/24  (k.kondo)  ǉ
    /// </remarks>
    private void ApplyToolTip()
    {
      if( chISOWriteHex.Checked )
      {
        m_toolTip1.SetToolTip( tbWriteTrack1, MSG_TOOLTIP_HEX );  //Hex`
        m_toolTip2.SetToolTip( tbWriteTrack2, MSG_TOOLTIP_HEX );  //Hex`
        m_toolTip3.SetToolTip( tbWriteTrack3, MSG_TOOLTIP_HEX );  //Hex`
      }
      else
      {
        m_toolTip1.SetToolTip( tbWriteTrack1, MSG_TOOLTIP_ASCII );  //Ascii`
        m_toolTip2.SetToolTip( tbWriteTrack2, MSG_TOOLTIP_ASCII );  //Ascii`
        m_toolTip3.SetToolTip( tbWriteTrack3, MSG_TOOLTIP_ASCII );  //Ascii`
      }
    }
    #endregion  ISOlCgCf[^eLXg{bNXpToolTip

  }
}

